# -*- coding: utf-8 -*-
from utils.common.fic_base import StepBaseInterface
from plugins.DistributedStorage.scripts.ManageConverge.implement.TC_ConfigB_KVMResourcePool import ConfigKVMResourcePool
from plugins.DistributedStorage.scripts.utils.iterm.ParameterGain import ParamsGain
from utils.DBAdapter.DBConnector import BaseOps
from utils.common.message import Message


class ConfigKVMResourcePoolIntf(StepBaseInterface):
    def __init__(self, project_id, pod_id):
        self.project_id = project_id
        self.pod_id = pod_id
        self.db = BaseOps()
        self.fs_args = ParamsGain(self.project_id, self.pod_id, self.db).get_manage_converge_args()
        self.config_kvm_resource_pool = ConfigKVMResourcePool(project_id, pod_id, self.fs_args)

    def pre_check(self, project_id, pod_id):
        """
        插件内部接口：执行安装前的资源预检查，该接口由execute接口调用，
        工具框架不会直接调用此接口
        :return:
        """
        return Message()

    def execute(self, project_id, pod_id):
        """
        标准调用接口：执行安装&配置
        :return: Message对象
        """
        control_id_list, control_ip_list = self.config_kvm_resource_pool.get_control_info(dc00x='dc002')
        self.fs_args['control_id_list'] = control_id_list
        self.fs_args['control_ip_list'] = control_ip_list
        self.fs_args['enabled_backend'] = self.fs_args['ha_backend_name']
        self.fs_args['az'] = 'dr-manage-az'
        return self.config_kvm_resource_pool.run()

    def rollback(self, project_id, pod_id):
        """
        标准调用接口：执行回滚
        :return: Message对象
        """
        return Message(200)

    def check(self, project_id, pod_id):
        """
        插件内部接口：执行注册，该接口由execute接口调用，
        工具框架不会直接调用此接口
        :return:
        """
        return Message(200)

    def retry(self, project_id, pod_id):
        """
        标准调用接口：重试
        :return:
        """
        return self.execute(project_id, pod_id)
